/*
 * MyersMillerAlign.h
 *
 *  Created on: Apr 17, 2013
 *      Author: Shahidul
 */

#ifndef MYERSMILLERALIGN_H
#define MYERSMILLERALIGN_H

#include "CommonDefinitions.h"

//int readFastaFiles(char input_file[], sequenceMap *refSeqMap);
int readFastaSequence(char input_file[], char pdb1[], char chain1[], char pdb2[], char chain2[], sequenceMap refSeqMap[]);
void alignFasta(sequenceMap refSeqMap[], sequenceMap refMap[], sequenceMap pdbTempMap[], basePairInfo basePairMapping[][MAX_BASE_PAIR], int basePairCountsMapping[]);
void AlignPDBWithRef(sequenceMap refSeqMap, atomInfo atomMList[], int atomMCount, sequenceMap *refMap, sequenceMap *pdbMap);
void chainAlign(chainMap *seqAlign1, chainMap *seqAlign2);
void chainAlignAnchorBased(chainMap *seqAlign1, chainMap *seqAlign2, sequenceMap refMap[], sequenceMap pdbTempMap[], basePairInfo basePairMapping[][MAX_BASE_PAIR], int basePairCountsMapping[]);
void getAnchor(helix helixListRef[MAX_HELIX_COUNT], int helixCount, basePairInfo basePairMapping[][MAX_BASE_PAIR], int basePairCountsMapping[], int minHelixLen, anchorMap anchorList[MAX_HELIX_COUNT], int *anchorCount);
int MMAlign(char seq1[], int m, char seq2[], int n, char *state, double *cost);

helix helixList[MAX_HELIX_COUNT];
int helixCount;
anchorMap anchorList[MAX_HELIX_COUNT];
int anchorCount;

sequenceMap refSeqsMap[MAX_ALIGN_PDB_COUNT];
int mapPDBsCount;

char *sequence1, *sequence2;

//Count the length of the alignment
int align_length;

//Pointers to dynamically allocate the memory for taking sequence and storing alignment
char *state;

//Vectors, as described in the article by Myers and Miller
double *cc, *dd, *rr, *ss;
double **w;
//char *temp_seq;

#endif /* MYERSMILLERALIGN_H */
