/*
 * UtilityFunctions.h
 *
 *  Created on: May 27, 2014
 *      Author: Shahidul
 */

#ifndef UTILITYFUNCTIONS_H_
#define UTILITYFUNCTIONS_H_

#include "CommonDefinitions.h"
#include <stdio.h>

void findHelices(basePairInfo basePairMapping[], int bpCount, int minHelixLen, helix helixList[MAX_HELIX_COUNT], int *helixCount, char helixOutFile[]);
void getCorrespondingDistance(edgeAtomCoordinates edgeAtoms[], int startIndex, int n, edgeAtomPair aEdgeAtomPairRef[], edgeAtomPair aEdgeAtomPair[]);
void closestNInteractions(edgeAtomCoordinates edgeAtoms[], int *n, edgeAtomPair aEdgeAtomPair[]);
edgeAtomName getEdgeAtomName(char edge, char residue);
double distance3D(coOrdinate3d coordA, coOrdinate3d coordB);
int isPurine(char c);
int isPyrimidine(char nucleotide);
int is_whitespace(char c);
int isCanonicalBP(basePairInfo aInfo);
int isWHS_BP(basePairInfo aInfo);
void printPairInfo(FILE* fpt, basePairInfo info, int skipNewLine);
void printPairRCAFormat(FILE* fpt, basePairInfo info, int skipNewLine);
void printPairMCAnnotateFormat(FILE* fpt, basePairInfo info, int skipNewLine);
void printPairRNAViewFormat(FILE* fpt, basePairInfo info, int skipNewLine);
void printPairRNAViewStack(FILE* fpt, basePairInfo info);
void printPairSimpleFormat(FILE* fpt, basePairInfo info, int skipNewLine);
void printPairInfoOnScreen(basePairInfo info);
void printPairMCAnnotateOnScreen(basePairInfo info);
int compBasePairAndEdge(const void *a, const void *b);
int compBasePairId(const void *a, const void *b);
int compareEdges(basePairInfo x, basePairInfo y);
void myTokenize(char str[], char delim[], char token[][LINE_SIZE], int *tokenCount, int ignoreExtraSpace);
void myTokenizeDynamic(char str[], char delim[], char **token, int *tokenCount, int ignoreExtraSpace);
void motifInitialization(motifIndices motifs[], int *motifCount, char pathCW[]);
void extractMotifInfo(motifIndices motifs[], int motifCount, char PDB[], char method[], basePairInfo basePairMap[MAX_BASE_PAIR], int basePairCount, char pathCW[]);
int compStr(const void*A, const void*B);
int mappedSeqComp(const void *a, const void *b);
annotationMethod getMethodId(char methodName[]);
void methodPrintToFile(annotationMethod aMethod, FILE*fpt);

#endif /* UTILITYFUNCTIONS_H_ */
